using IRaCIS.Core.Domain.Share;
namespace IRaCIS.Core.Domain.Models;

[Comment("̨ - ֵҪͬ")]
[Table("Dictionary")]
public partial class Dictionary : BaseFullAuditEntity
{
    #region 
    [JsonIgnore]
    public List<DoctorDictionary> DoctorDicRelationList { get; set; } = new List<DoctorDictionary>();
    [JsonIgnore]
    [ForeignKey("ConfigTypeId")]
    public Dictionary ConfigDictionary { get; set; }

    [JsonIgnore]
    [ForeignKey("ParentId")]
    public Dictionary Parent { get; set; }
    [JsonIgnore]
    public List<Dictionary> ChildList { get; set; } = new List<Dictionary>();

    #endregion
    [StringLength(400)]
    public string ChildGroup { get; set; } = null!;

    public string Code { get; set; } = null!;

    public Guid? ConfigTypeId { get; set; }

    [Comment("ֵ- ö|bool|")]
    public DicDataTypeEnum DataTypeEnum { get; set; }

    [StringLength(512)]
    public string Description { get; set; } = null!;

    [Comment("Ƿֵ")]
    public bool IsConfig { get; set; }

    public bool IsEnable { get; set; }

    public Guid? ParentId { get; set; }

    public int ShowOrder { get; set; }

    [StringLength(400)]
    public string Value { get; set; } = null!;

    [StringLength(400)]
    public string ValueCN { get; set; } = null!;
}
