namespace IRaCIS.Core.Domain.Models;

[Comment("ҽ - ҽֵ")]
[Table("DoctorDictionary")]
public class DoctorDictionary : Entity
{
    #region 
    [JsonIgnore]
    [ForeignKey("DoctorId")]
    public Doctor Doctor { get; set; }

    [JsonIgnore]
    [ForeignKey("DictionaryId")]
    public Dictionary Dictionary { get; set; }
    #endregion

    public Guid DictionaryId { get; set; }

    public Guid DoctorId { get; set; }

    [StringLength(400)]
    public string KeyName { get; set; } = null!;
}
