namespace IRaCIS.Core.Domain.Models;

[Comment("ҽ - ")]
[Table("Postgraduate")]
public  class Postgraduate : BaseFullAuditEntity
{
    #region 

    #endregion

    public Guid DoctorId { get; set; }

    [Column(TypeName = "date")]
    public DateTime? BeginDate { get; set; }

    [Column(TypeName = "date")]
    public DateTime? EndDate { get; set; }

    [StringLength(50)]
    public string Training { get; set; } = string.Empty;

    [StringLength(100)]
    public string Major { get; set; } = string.Empty;

    [StringLength(100)]
    public string Hospital { get; set; } = string.Empty;

    [StringLength(100)]
    public string School { get; set; } = string.Empty;
    [StringLength(100)]
    public string Country { get; set; } = string.Empty;

    [StringLength(100)]
    public string Province { get; set; } = string.Empty;

    [StringLength(100)]
    public string City { get; set; } = string.Empty;

    [StringLength(50)]
    public string TrainingCN { get; set; } = string.Empty;

    [StringLength(100)]
    public string MajorCN { get; set; } = string.Empty;

    [StringLength(100)]
    public string HospitalCN { get; set; } = string.Empty;

    [StringLength(100)]
    public string SchoolCN { get; set; } = string.Empty;
    [StringLength(100)]
    public string CountryCN { get; set; } = string.Empty;

    [StringLength(100)]
    public string ProvinceCN { get; set; } = string.Empty;

    [StringLength(100)]
    public string CityCN { get; set; } = string.Empty;
}
