namespace IRaCIS.Core.Domain.Models;

[Comment("ҽƷ - ͬʱ۸")]
[Table("RankPrice")]
public partial class RankPrice : BaseFullAuditEntity
{
    [StringLength(200)]
    public string RankName { get; set; } = string.Empty;

    [DecimalPrecision(18, 2)]
    public decimal Timepoint { get; set; }

    [DecimalPrecision(18, 2)]
    public decimal TimepointIn24H { get; set; }

    [DecimalPrecision(18, 2)]
    public decimal TimepointIn48H { get; set; }

    [DecimalPrecision(18, 2)]
    public decimal Adjudication { get; set; }

    [DecimalPrecision(18, 2)]
    public decimal AdjudicationIn24H { get; set; }

    [DecimalPrecision(18, 2)]
    public decimal AdjudicationIn48H { get; set; }

    [DecimalPrecision(18, 2)]
    public decimal Global { get; set; }

    [DecimalPrecision(18, 2)]
    public decimal Training { get; set; }

    [DecimalPrecision(18, 2)]
    public decimal Downtime { get; set; }

    [DecimalPrecision(18, 2)]
    public decimal RefresherTraining { get; set; }
    public int ShowOrder { get; set; }
}
