﻿namespace IRaCIS.Core.Domain.Models;
public interface IAuditAdd<TKey> where TKey : struct
{
    public TKey CreateUserId { get; set; }

    public DateTime CreateTime { get; set; }

}
public interface IAuditAdd : IAuditAdd<Guid>
{

}

public interface IAuditAddWithUserName : IAuditAdd<Guid>
{
    public string CreateUser { get; set; }
}
