﻿using Microsoft.EntityFrameworkCore.Design;

namespace IRaCIS.Core.Infra.EFCore.Context;


/// <summary>
/// Design-time DbContext Creation  用于迁移时指定使用哪个数据库
/// </summary>
public class IRaCISDBContextFactory : IDesignTimeDbContextFactory<IRaCISDBContext>
{
    public IRaCISDBContext CreateDbContext(string[] args)
    {
        var optionsBuilder = new DbContextOptionsBuilder<IRaCISDBContext>();
        optionsBuilder.UseSqlServer("Server=106.14.89.110,1435;Database=Test_IRC;User ID=sa;Password=xc@123456;TrustServerCertificate=true", contextOptionsBuilder => contextOptionsBuilder.EnableRetryOnFailure());

        return new IRaCISDBContext(optionsBuilder.Options);
    }
}

